**Привет дорогой друг!**

Ну что же, вот тестовое задание. Оно состоит из нескольких  задач разного типа и сложности.
Это позволит нам определить уровень владения технологиями, с которыми мы работаем, и понять сможем ли мы развиваться вместе и учиться у друг друга.

- Для проверки задания необходимо предоставить ссылку на публичный репозиторий (github, bitbucket, gitlab), в идеале url с тестовым сайтом.   
- все изменения в БД должны быть реализованы последовательными миграцииями, соответствующими изменениям в коде.
- Проект должен работать в докер контейнерах.
- Желаемый результат по развертыванию, который хотим увидеть - клонировать репозиторий, запустить миграции, запустить консольную команду для парсинга книг. Реализация при помощи Makefile приветствуется.


# Тестовое задание Symfony

* **Для реализации необходимо использовать БД - MySql/MariaDB**
* **Версия PHP >= 7.3**

Необходимо реализовать:
1. Админ панель
2. Авторизацию
2. Парсинг книг с файла json
2. Категории книг
2. Детальный просмотр книги
2. Форма обратной связи
2. Поиск книг по названию, автору, статусу (**опционально**)
2. Фильтр книг по двум параметрам. Например по Автору и Дате публикации (**опционально**)


## 0. Настройки приложения
Поведение сайта (как приложения в широком смысле) должно поддаваться настройки. Как будет реализована эта настройка - решай сам.
В настройках должны быть параметры:
* Кол-во элементов на страницу (для книг)
* Email адрес получателя сообщения с формы обратной связи
* Источник данных для парсинга (url)

## 1. Админ панель
* CRUD элемента - книга (с возможностью загрузки изображения к элементу)
* CRUD категории (возможность настраивать вложенные категорий)
* Просмотр заявок с формы обратной связи
* Использовать EasyAdmin для админ части (**опционально**)

## 2. Авторизация
Авторизация может быть реализована штатными средствами yii2.
admin:admin

## 3. Форма обратной связи
Для заполнения доступны поля:
* Email (**обязательное поле**)
* Имя
* Сообщение (**обязательное поле**)
* Телефон

Все поля должны валидироваться, на форме должна присутствовать **ReCAPTCHA**.
Форма должна отправлять email получателю (из указанного email в настройках).
Отправленные сообщения должны хранится в БД.

## 4. Парсинг книг из файла 
> **Источник данных** https://gitlab.grokhotov.ru/hr/yii-test-vacancy/-/blob/master/books.json 

Необходимо реализовать:
* Через консоль - парсинг книг, категорий из источника.
* Изображения к книгам должны быть загружены на сервер.
* При повторном парсинге элементы не должны дублироваться(если появятся новые книги, то парсер их должен добавить).
* Если у товара нет категории, добавлять товар в категорию **Новинки**
* Рекомендации по улучшению сценария парсинга (**опционально**). Можно их пометить комментариями //TODO в коде или сразу реализовать.

## 5. Категории книг
На главной странице сайта, необходимо выводить категории верхнего уровня.
Если у категории есть подкатегории, то при переходе в категорию, выводить её под-категории.
Если у категории нет подкатегорий, есть только книги, выводить книги. С учетом пагинации
Книги из под-категорий категории также должны выводится на странице категории с учетом пагинации. (**опционально**)

## 6. Детальный просмотр книги
В детальном просмотре необходимо отображать:
* Изображение книги
* Название книги
* Категории в которой находится книга (кликабельны)
* Кол-во страниц
* isbn номер как артикул
* Книги из текущей категории(если имеются такие) (**опционально**)
* Рекомендации по улучшению вывода информации о книги в интерфейсе сайта (**опционально**). Можно их пометить комментариями //TODO в коде или сразу реализовать.

## 7. Поиск книг по названию, автору, статусу
В категориях реализовать фильтр по:
* Названию книги (название содержит)
* Автор (название содержит)
* Статусу (select)

## 8. Структура проекта
Требований к структуре проекта нет, но она как раз таки и будет оцениваться в первую очередь. В том числе:
- правильное разделение MVC,
- использование стандартных инструментов Symfony,
- настройка докер контейнеров (тонкости DevOps не требуются, достаточно показать понимание современной архитектуры серверного приложения)

